Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.uka.ipd.consensus.foundation
Class ConsensusFoundation

    java.lang.Object
      de.uka.ipd.consensus.foundation.ConsensusFoundation

All Implemented Interfaces:
  ConsensusFoundationManager

public class ConsensusFoundation
extends Object
implements ConsensusFoundationManager

This is the main class of the ConsensusFoundation framework that initializes and provides easy access to all available modules.

To initialize the framework, create an instance of this class and pass a configuration file to the constructor (or use the default config file).

Version:
  2006-06-14
Author:
  Thomas Much

Field Summary
`static String` | `CF_DYNRIGHTS_KEY` The configuration key that defines the DynamicRightsManager (optional).
`static String` | `CF_EVOLUTION_KEY` The configuration key that defines the EvolutionManager (optional).
`static String` | `CF_EXPORT_KEY` The configuration key that defines the ExportHandlers (comma separated list) in addition to any default handlers (optional).
`static String` | `CF_IMPORT_KEY` The configuration key that defines the ImportHandlers (comma separated list) in addition to any default handlers (optional).
`static String` | `CF_INCENTIVE_KEY` The configuration key that defines the IncentiveManager (optional).
`static String` | `CF_LOGGING_KEY` The configuration key that defines the LoggingManager.
`static String` | `CF_LOGLEVEL_KEY` The configuration key that defines the loglevel (optional).
`static String` | `CF_ONTOLOGY_KEY` The configuration key that defines the OntologyManager.
`static String` | `CF_PROPERTIES` If no config file name is passed to the constructor and a file with this name is found on the classpath, it is used as the configuration properties file.
`static String` | `CF_QUERY_KEY` The configuration key that defines the QueryEngine if an implementation other than the default one shall be used (optional).
`static String` | `CF_RATING_KEY` The configuration key that defines the RatingManager (optional).
`static String` | `CF_SCORING_KEY` The configuration key that defines the ScoringListeners as a comma separated list (optional).
`static String` | `CF_SUPERADMIN_KEY` The value of this property key names the user that is granted the superadmin role on login, regardless what roles the UserManager assigns to the user.
`static String` | `CF_USER_KEY` The configuration key that defines the UserManager.

Constructor Summary
`ConsensusFoundation()` Initializes the framework and its components with the configuration file defined by `CF_PROPERTIES`.
`ConsensusFoundation(Properties config)` Initializes the framework and its components with the given Properties object.
`ConsensusFoundation(String configFile)` Initializes the framework and its components with the given configuration file.

Method Summary
`protected void` | `finalize()` Calls `shutdown()` if the application forgot to do so.
`DynamicRightsManager` | `getDynamicRightsManager()` Returns a reference to the DynamicRightsManager.
`EvolutionManager` | `getEvolutionManager()` Returns a reference to the EvolutionManager.
`IncentiveManager` | `getIncentiveManager()` Returns a reference to the IncentiveManager.
`LoggingManager` | `getLoggingManager()` Returns a reference to the LoggingManager.
`OntologyManager` | `getOntologyManager()` Returns a reference to the OntologyManager.
`RatingManager` | `getRatingManager()` Returns a reference to the RatingManager.
`UserManager` | `getUserManager()` Returns a reference to the UserManager.
`String` | `getVersion()` Returns a version string of the implementation of the ConsensusFoundation framework.
`protected void` | `init(Properties config)` Called by the constructor before the modules are instantiated and their `init()` method is called.
`protected void` | `initCompleted(Properties config)` Called by the constructor after the `init()` method of all available modules has been called, but before their `initCompleted()` method is called.
`void` | `shutdown()` An application must call this method to shut down the framework and its components.

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### CF_PROPERTIES

    public static final String CF_PROPERTIES

  If no config file name is passed to the constructor and a file with this name is found on the classpath, it is used as the configuration properties file.

  See Also:
    Constant Field Values

### CF_SUPERADMIN_KEY

    public static final String CF_SUPERADMIN_KEY

  The value of this property key names the user that is granted the superadmin role on login, regardless what roles the UserManager assigns to the user. A user with this role can assign the admin role to other users (and revoke it).

  See Also:
    Constant Field Values

### CF_LOGGING_KEY

    public static final String CF_LOGGING_KEY

  The configuration key that defines the LoggingManager.

  See Also:
    `LoggingManager`, `CF_PROPERTIES`, Constant Field Values

### CF_USER_KEY

    public static final String CF_USER_KEY

  The configuration key that defines the UserManager.

  See Also:
    `UserManager`, `CF_PROPERTIES`, Constant Field Values

### CF_ONTOLOGY_KEY

    public static final String CF_ONTOLOGY_KEY

  The configuration key that defines the OntologyManager.

  See Also:
    `OntologyManager`, `CF_PROPERTIES`, Constant Field Values

### CF_EVOLUTION_KEY

    public static final String CF_EVOLUTION_KEY

  The configuration key that defines the EvolutionManager (optional).

  See Also:
    `EvolutionManager`, `CF_PROPERTIES`, Constant Field Values

### CF_RATING_KEY

    public static final String CF_RATING_KEY

  The configuration key that defines the RatingManager (optional).

  See Also:
    `RatingManager`, `CF_PROPERTIES`, Constant Field Values

### CF_INCENTIVE_KEY

    public static final String CF_INCENTIVE_KEY

  The configuration key that defines the IncentiveManager (optional).

  See Also:
    `IncentiveManager`, `CF_PROPERTIES`, Constant Field Values

### CF_DYNRIGHTS_KEY

    public static final String CF_DYNRIGHTS_KEY

  The configuration key that defines the DynamicRightsManager (optional).

  See Also:
    `DynamicRightsManager`, `CF_PROPERTIES`, Constant Field Values

### CF_SCORING_KEY

    public static final String CF_SCORING_KEY

  The configuration key that defines the ScoringListeners as a comma separated list (optional).

  See Also:
    `ScoringListener`, Constant Field Values

### CF_QUERY_KEY

    public static final String CF_QUERY_KEY

  The configuration key that defines the QueryEngine if an implementation other than the default one shall be used (optional).

  See Also:
    `QueryEngine`, Constant Field Values

### CF_EXPORT_KEY

    public static final String CF_EXPORT_KEY

  The configuration key that defines the ExportHandlers (comma separated list) in addition to any default handlers (optional).

  See Also:
    `ExportHandler`, Constant Field Values

### CF_IMPORT_KEY

    public static final String CF_IMPORT_KEY

  The configuration key that defines the ImportHandlers (comma separated list) in addition to any default handlers (optional).

  See Also:
    `ImportHandler`, Constant Field Values

### CF_LOGLEVEL_KEY

    public static final String CF_LOGLEVEL_KEY

  The configuration key that defines the loglevel (optional).

  See Also:
    `LoggingManager`, Constant Field Values

Constructor Detail

### ConsensusFoundation

    public ConsensusFoundation()
                        throws Exception

  Initializes the framework and its components with the configuration file defined by `CF_PROPERTIES`.

Throws:
  `Exception` - if an error occurred before the framework was initialized completely
See Also:
  `CF_PROPERTIES`

### ConsensusFoundation

    public ConsensusFoundation(Properties config)
                        throws Exception

  Initializes the framework and its components with the given Properties object.

Parameters:
  `config` - the Properties object containing the configuration keys
Throws:
  `Exception` - if an error occurred before the framework was initialized completely

### ConsensusFoundation

    public ConsensusFoundation(String configFile)
                        throws Exception

  Initializes the framework and its components with the given configuration file.

Parameters:
  `configFile` - the properties file containing the configuration keys
Throws:
  `Exception` - if an error occurred before the framework was initialized completely

Method Detail

### init

    protected void init(Properties config)
                 throws Exception

  Called by the constructor before the modules are instantiated and their `init()` method is called.

  Parameters:
    `config` - all entries from `ConsensusFoundation.properties`
  Throws:
    `Exception` - if any error occurs (startup of the application is aborted in this case)
  See Also:
    `ConsensusFoundation()`

### initCompleted

    protected void initCompleted(Properties config)
                          throws Exception

  Called by the constructor after the `init()` method of all available modules has been called, but before their `initCompleted()` method is called.

  Parameters:
    `config` - all entries from `ConsensusFoundation.properties`
  Throws:
    `Exception` - if any error occurs (startup of the application is aborted in this case)

### getLoggingManager

    public LoggingManager getLoggingManager()

  Description copied from interface: `ConsensusFoundationManager`
  Returns a reference to the LoggingManager.

  Specified by:
    `getLoggingManager` in interface `ConsensusFoundationManager`
  Returns:
    the LoggingManager instance, never `null` after successful startup

### getUserManager

    public UserManager getUserManager()

  Description copied from interface: `ConsensusFoundationManager`
  Returns a reference to the UserManager.

  Specified by:
    `getUserManager` in interface `ConsensusFoundationManager`
  Returns:
    the UserManager instance, never `null` after successful startup

### getOntologyManager

    public OntologyManager getOntologyManager()

  Description copied from interface: `ConsensusFoundationManager`
  Returns a reference to the OntologyManager.

  Specified by:
    `getOntologyManager` in interface `ConsensusFoundationManager`
  Returns:
    the OntologyManager instance, never `null` after successful startup

### getEvolutionManager

    public EvolutionManager getEvolutionManager()

  Description copied from interface: `ConsensusFoundationManager`
  Returns a reference to the EvolutionManager.

  Specified by:
    `getEvolutionManager` in interface `ConsensusFoundationManager`
  Returns:
    the EvolutionManager instance or `null` if an EvolutionManager is not available

### getIncentiveManager

    public IncentiveManager getIncentiveManager()

  Description copied from interface: `ConsensusFoundationManager`
  Returns a reference to the IncentiveManager.

  Specified by:
    `getIncentiveManager` in interface `ConsensusFoundationManager`
  Returns:
    the IncentiveManager instance or `null` if an IncentiveManager is not available

### getRatingManager

    public RatingManager getRatingManager()

  Description copied from interface: `ConsensusFoundationManager`
  Returns a reference to the RatingManager.

  Specified by:
    `getRatingManager` in interface `ConsensusFoundationManager`
  Returns:
    the RatingManager instance or `null` if a RatingManager is not available

### getDynamicRightsManager

    public DynamicRightsManager getDynamicRightsManager()

  Description copied from interface: `ConsensusFoundationManager`
  Returns a reference to the DynamicRightsManager.

  Specified by:
    `getDynamicRightsManager` in interface `ConsensusFoundationManager`
  Returns:
    the DynamicRightsManager instance or `null` if a DynamicRightsManager is not available

### shutdown

    public void shutdown()

  An application must call this method to shut down the framework and its components. This method calls the `shutdown()` method of each module.

  See Also:
    `ConsensusFoundationModule.shutdown()`

### finalize

    protected void finalize()
                     throws Throwable

  Calls `shutdown()` if the application forgot to do so.

  Throws:
    `Throwable`
  See Also:
    `shutdown()`

### getVersion

    public String getVersion()

  Description copied from interface: `ConsensusFoundationManager`
  Returns a version string of the implementation of the ConsensusFoundation framework.

  Specified by:
    `getVersion` in interface `ConsensusFoundationManager`
  Returns:
    the version of the framework's implementation
  See Also:
    `getVersion()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD